#ifndef _H_MACH1
#define _H_MACH1

#include <vector>
#include <iostream>
#include "Machines.h"

class Mach1 : public Machines{
private:

public:
	std::vector<double> A1;
	std::vector<std::pair<double, std::pair<double, int> > > C1;
	std::vector<std::pair<double, std::pair<double, int> > > Armazem;
	std::vector<double> A_M1;
	std::vector<std::pair<double, std::pair<double, int> > > Cc;

	Mach1::Mach1()
	{
	}

	Mach1::~Mach1()
	{
	}

	void ActivateMach1()
	{
		A1.clear();
		C1.clear();
		Armazem.clear();
		A_M1.clear();
		Cc.clear();
		A1 = Plataformas::Plataforma_Artigos;
		C1 = Plataformas::Plataforma_Empacotamento;
		Armazem = Plataformas::Caixas_Vazias;
	}

	int ChoseBox(double artigo)
	{
		std::vector<int> caixas;
		int caixa = -1;

		for(int i=0; i<=static_cast<int>(C1.size())-1; i++)
		{
			if(C1[i].second.first >= artigo)
				caixas.push_back(i);
		}

		if(caixas.size() >= 1)
			caixa = caixas[0];
		caixas.clear();
		return caixa;
	}

	void RunMach1()
	{
		for(int i=0; i<=static_cast<int>(A1.size())-1; i++)
		{
			std::cout << std::endl;
			std::cout << "Artigo: " << A1[i] << std::endl;

			int Feito = 0;
			int caixaescolhida = 0;
			for(int j=0; j<=static_cast<int>(C1.size())-1; j++)
			{
				caixaescolhida = ChoseBox(A1[i]);
				if(caixaescolhida !=1)
				{
					Machines::Empacotamento(C1, A1, caixaescolhida, i);
					if(Machines::CheckFullBoxes(C1, caixaescolhida) == 1)
						Plataformas::FecharCaixa(C1, Cc, Armazem, caixaescolhida);
					Feito = 1;
					if(i!=static_cast<int>(A1.size())-1)
						i--;
					break;
				}
				if(Feito == 0)
				{
					Machines::Empacotamento_Manual(A1, A_M1, i);
					if(i!=static_cast<int>(A1.size())-1)
						i--;
					break;
				}
			}
		}
		Machines::Resultados(C1, Cc, A_M1);
	}
};

#endif
